/*-
 * Copyright (c) 2001, Ramsey G. Brenner <rgbrenner@myrealbox.com>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#include "typingtutor.h"

void chart(void)
{
    int      cnt;
    int      cnt1;
    int      lesson[5];
    int      total;
    char    *buf;
    char    *shrt_lessn_names;
    FILE    *fp;
    char    lessn_grps[13][14] = {"Home keys", "Stretching out", "Reaching down",
                    "Top-left", "Top-right", "Bottom-left",
                    "Capitalization", "Puctuaction", "Left-hand",
                    "Right-hand", "Remaining", "Number pad",
                    "Skill-building"};
    char    shrt_lessn_grps[13][16] = {"+home\n", "+stretch\n", "+reach\n",
                    "+topleft\n", "+topright\n", "+bottomleft\n",
                    "+capitalization\n", "+puctuaction\n", "+lefthand\n",
                    "+righthand\n", "+remaining\n", "+numberpad\n",
                    "+skillbuilding\n"};

    fp = lfopen("log", NULL, "r");
    if((buf = malloc(80)) == NULL) {
        fprintf(stderr, "Memory allocation error!\n");
        exit(EXIT_FAILURE);
    }
    if((shrt_lessn_names = malloc(30)) == NULL) {
        fprintf(stderr, "Memory allocation error!\n");
        exit(EXIT_FAILURE);
    }
    system("clear");
    printf("\n\t\t\t\t History Chart\n\n\n");
    printf("\t   Lesson\t|    1\t    2\t    3\t    4\t   test\t|  Total\n\n");
    for(cnt = 0; cnt < 13; cnt++) {
        strcpy(shrt_lessn_names, shrt_lessn_grps[cnt]);
        for(cnt1 = 0; cnt1 < 5; cnt1++)
            lesson[cnt1] = NULL;
        for(;;) {
            fgets(buf, 80, fp);
            if(feof(fp))
                break;
            if(buf[0] != '+' || strcmp(buf, shrt_lessn_names))
                continue;
            fgets(buf, 80, fp);
            if(buf[strlen(buf) - 1] == '\n')
                buf[strlen(buf) - 1] = NULL;
            if(!strncmp(buf + 1, "test", 4))
                lesson[4] += 1;
            else if(atoi(buf + 1) < 5)
                lesson[atoi(buf + 1) - 1] += 1;
        }
        for(cnt1 = 0, total = 0; cnt1 < 5; cnt1++)
            total += lesson[cnt1];
        printf("\t %s\t|", lessn_grps[cnt]);
        for(cnt1 = 0; cnt1 < 5; cnt1++) {
            if(lesson[cnt1] < 100)
                printf("   ");
            else if(lesson[cnt1] > 100)
                printf("  ");
            if(lesson[cnt1] > 0)
                printf("%d\t|", lesson[cnt1]);
            else
                printf("\t|");
        }
        if(total < 10)
            printf("    ");
        else if(total > 10)
            printf("   ");
        printf("%d\n", total);
        rewind(fp);
    }
    printf("\n\n");
    free(buf);
    free(shrt_lessn_names);
    fclose(fp);
}
