/*-
 * Copyright (c) 2001, Ramsey G. Brenner <rgbrenner@myrealbox.com>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#include "typingtutor.h"

extern char *home_dir;

void history(char *les, char *dril)
{
    int      cnt = 0;
    int      cnt1 = 0;
    int      total = 0;
    FILE    *fp;
    char     buffer[2][6][80];
    char    *less;
    char    *drill = NULL;
    char    *histor = NULL;
    char     ans[5];

    if(!strcmp(les, "delete")) {
        printf("%s\n%s",
            "This will remove all your history.",
            "Are you sure you want to proceed (yes/no)? ");
        fgets(ans, 5, stdin);
        fflush(stdin);
        if(*ans == 'y') {
            if((histor = malloc(strlen(home_dir) + sizeof("/.typingtutor/log"))) == NULL) {
                fprintf(stderr, "Memory allocation error!\n");
                exit(EXIT_FAILURE);
            }
            strcpy(histor, home_dir);
            strcat(histor, "/.typingtutor/log");
            remove(histor);
            fclose(lfopen("log", NULL, "w"));
            free(histor);
        }
        return;
    }
    if((less = malloc(strlen(les) + sizeof("+"))) == NULL) {
        fprintf(stderr, "Memory allocation error!\n");
        exit(EXIT_FAILURE);
    }
    strcpy(less, "+");
    strcat(less, les);
    system("clear");
    printf("\t\t\t\t  History\n");
    if(strncmp(les, "all", 3)) {
        lesson(les, NULL);
        if(dril != NULL) {
            lesson(NULL, dril);
            if((drill = malloc(strlen(dril) + sizeof("+"))) == NULL) {
                fprintf(stderr, "Memory allocation error!\n");
                exit(EXIT_FAILURE);
            }
            strcpy(drill, "+");
            strcat(drill, dril);
        }
    }
    fp = lfopen("log", NULL, "r");
    printf("\n");
    for(;;) {
        for(cnt = 0; cnt <= 5; cnt++) {
            buffer[0][cnt][0] = NULL;
            buffer[1][cnt][0] = NULL;
        }
        for(cnt = 0;; cnt++) {
            if(cnt == 6)
                cnt = 0;
            fgets(buffer[0][cnt], 80, fp);
            if(buffer[0][cnt][strlen(buffer[0][cnt]) - 1] == '\n')
                buffer[0][cnt][strlen(buffer[0][cnt]) - 1] = NULL;
            if(feof(fp)) {
                ***buffer = NULL;
                break;
            }
            if(cnt == 5 && !strcmp(les, "all"))
                break;
            else if(!strncmp(*buffer[0], less, strlen(less)) && cnt == 5) {
                if(dril != NULL) {
                    if(!strncmp(buffer[0][1], drill, strlen(drill)))
                        break;
                    else
                        continue;
                }
                break;
            }
        }
        for(cnt = 0;; cnt++) {
            if(cnt == 6)
                cnt = 0;
            fgets(buffer[1][cnt], 80, fp);
            if(buffer[1][cnt][strlen(buffer[1][cnt]) - 1] == '\n')
                buffer[1][cnt][strlen(buffer[1][cnt]) - 1] = NULL;
            if(feof(fp)) {
                **buffer[1] = NULL;
                break;
            }
            if(cnt == 5 && !strcmp(les, "all"))
                break;
            else if(!strncmp(*buffer[1], less, strlen(less)) && cnt == 5) {
                if(dril != NULL) {
                    if(!strncmp(buffer[1][1], drill, strlen(drill)))
                        break;
                    else
                        continue;
                }
                break;
            }
        }
        cnt1 = cnt = 0;
        if(**buffer[0] == NULL && **buffer[1] == NULL)
            break;
        if(**buffer[0] != NULL) {
            printf("  %s\t\t", buffer[0][2] + 1);
            total++;
            cnt = 1;
        } else
            printf("\n");
        if(**buffer[1] != NULL) {
            printf("  %s\n", buffer[1][2] + 1);
            total++;
            cnt1 = 1;
        } else
            printf("\n");
        if(cnt == 1)
            printf("%s%s\t", "   Gross Words Per Minute: ",
        buffer[0][3] + 1);
        if(strlen(buffer[0][3] + 1) <= 4)
            printf("\t");
        if(cnt1 == 1)
            printf("%s%s\n", "   Gross Words Per Minute: ",
                buffer[1][3] + 1);
        else
            printf("\n");
        if(cnt == 1)
            printf("%s%s\t", "   Net Words Per Minute: ",
                buffer[0][4] + 1);
        if(strlen(buffer[0][4] + 1) <= 6)
            printf("\t");
        if(cnt1 == 1)
            printf("%s%s\n", "   Net Words Per Minute: ",
                buffer[1][4] + 1);
        else
            printf("\n");
        if(cnt == 1)
            printf("%s%s\t\t", "   Percent Accuracy: ",
                buffer[0][5] + 1);
        if(cnt1 == 1)
            printf("%s%s\n\n", "   Percent Accuracy: ",
                buffer[1][5] + 1);
        else
            printf("\n");
    }
    if(total % 2 && total != 0)
        printf("\n");
    free(drill);
    free(less);
    fclose(fp);
}
