/*-
 * Copyright (c) 2001, Ramsey G. Brenner <rgbrenner@myrealbox.com>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#include "typingtutor.h"

void input(int argc, char *les, char *dril)
{
    int      cnt;
    char     buffer[76];
    char     input[76];
    FILE    *drill;
    double   total_wrong = 0;
    double   total_typed = 0;
    double   total = 0;
    time_t   start;
    time_t   finish;

    drill = lfopen(les, dril, "r");
    if(argc == 3)
        instruct(les);
    system("clear");
    lesson(les, dril);
    start = time(0);
    while(buffer[0] != '\n') {
        fflush(stdin);
        fgets(buffer, 76, drill);
        printf("\n   %s   ", buffer);
        if(buffer[0] == '\n')
            break;
        fgets(input, 76, stdin);
        buffer[strlen(buffer) - 1] = NULL;
        input[strlen(input) - 1] = NULL;
        for(cnt = 0; cnt < strlen(input); cnt++)
            if(input[cnt] != buffer[cnt])
                total_wrong += 1;
        total_typed += strlen(input);
        total += strlen(buffer);
        if(input[strlen(input) - 1] == ' ') {
            total_wrong -= 1;
            total_typed -= 1;
        }
    }
    finish = time(0);
    fclose(drill);
    results(start, finish, total, total_wrong, total_typed, les, dril);
}
