/*-
 * Copyright (c) 2001, Ramsey G. Brenner <rgbrenner@myrealbox.com>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#include "typingtutor.h"

extern char lessons[15][15];

void instruct(char *les)
{
    int      cnt;
    char    *less[15] = {
"\t\tTry to type as many words as you can,\n\
 \t\t\tYou have 60 seconds.\n",

"\t\t Use your thumbs to hit the space bar.\n\
 \t\tKeep your eyes on the copy and tap the\n\
 \t\t        keys - don't push them.\n",

"\t\tTake your time getting familiar with the\n\
 \t\t new reaches, and quickly return to the\n\
 \t\t   home keys after each reach is done.\n",

"\t\tKeep returning to the home keys after\n\
 \t\t    each reach - and no peeking!\n",

"\t\tKeep your forefinger in place while you\n\
 \t\t       reach with your pinkie.\n",

"\t\tThe pinkie reaches are probably the\n\
 \t\t     hardest, but keep trying.\n",

"\t\tBe careful not to hit the Shift key when\n\
 \t\t  you're reaching for Z - keeping your\n\
 \t\t  forefinger anchored on the home row\n\
 \t\t                 help.\n",

"\t\t Use the pinkie of the opposite hand to\n\
 \t\t depress the Shift key. Make sure that\n\
 \t\tShift is down before you press the letter\n\
 \t\t    key, or you won't get a capital.\n",

"\t\tSpacing matters! Space twice after ends\n\
 \t\t  of sentences [including .?: and !].\n\
 \t\t     Space once after commas, and\n\
 \t\t              semicolons.\n",

"\t\tDon't forget to return to the home row\n\
 \t\t	       between reaches.\n",

"\t\tFocus on frequently-used numbers and\n\
 \t\t    symbols such as 0 - [ and ].\n",

"\t\tThe reaches are tough, but you're a pro\n\
 \t\t    by now - one who knows to keep\n\
 \t\t      returning to the home row.\n",

"\t\t 4, 5 and 6 are your home keys. Use\n\
 \t\tyour pinkie to punch Enter after each\n\
 \t\t string of numbers or equation. Don't\n\
 \t\t    forget to turn Num Lock on.\n",

"\t\tType words as units, not as individual\n\
 \t\t letters, and your speed will improve.\n\
 \t\t   Typing sentences backward is an\n\
 \t\t effective drill. Aim for a net w.p.m\n\
 \t\t           of 60 or higher.\n"
};

    for(cnt = 0; cnt < 16; cnt++)
        if(0 == strcmp(les, lessons[cnt]))
            break;
    system("clear");
    printf("\n\n\t\t\t%s\n\t\t\t%s\n\n",
        "Start Typing As Soon As",
        "This Message Disappears");
    printf("%s", less[cnt]);
    sleep(4);
}
