/*-
 * Copyright (c) 2001, Ramsey G. Brenner <rgbrenner@myrealbox.com>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#include "typingtutor.h"

int chk_lesson(char *);

extern char lessons[15][15];

void lesson(char *les, char *dril)
{
    int      cnt = 0;
    char    less[14][30] = {"Home keys", "Stretching out", "Reaching down",
                  "All the top left row", "All the top right row",
                  "All the bottom left row", "Shift key/capitalization",
                  "Punctuation keys", "Left-hand numbers and symbols",
                  "Right-hand numbers and symbols", "All remaining keys",
                  "Number pad", "Skill-building", "Custom"};

    if(les != NULL) {
        for(cnt = 0; cnt < 16; cnt++)
            if(!strcmp(les, lessons[cnt]))
                break;
        if(cnt < 16)
            printf("%s%s\n",
                "Lesson: ", less[cnt - 1]);
        else
            printf("%s%s\n",
                "Lesson: ", les);
    }
    if(dril != NULL)
        printf("%s%s\n",
            "Drill: ", dril);
}

int chk_lessn_grp(char *les)
{
    int cnt;

    if(les != NULL) {
        for(cnt = 0; cnt < 16; cnt++)
            if(!strcmp(les, lessons[cnt]))
                break;
        if(cnt < 16)
            return(1);
        else
            return(0);
    }
    else
        return(0);
}
