/*-
 * Copyright (c) 2001, Ramsey G. Brenner <rgbrenner@myrealbox.com>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#include "typingtutor.h"

void results(time_t start, time_t finish, double total, double total_wrong, double total_typed, char *les, char *dril)
{
    double  gwpm;
    double  nwpm;
    double  percent_right;
    time_t  elapsed;

    elapsed = difftime(finish, start);
    percent_right = percent(total_typed, total_typed - total_wrong);
    gwpm = gross_wpm(total_typed, elapsed);
    nwpm = net_wpm(total_typed, total_wrong, elapsed);
    if(total_typed >= total - (total / 6)) {
        printf("\n\n%s%d seconds\n%s%d\n%s%d\n%s%.2f\n%s%.2f\n%s%.2f\n",
            "Elapsed Time: ", (int)elapsed,
            "Correct Keystrokes: ", (int)(total_typed - total_wrong),
            "Incorrect Keystrokes: ", (int)total_wrong,
            "Gross Words Per Minute: ", gwpm,
            "Net Words Per Minute: ", nwpm,
            "Percent Accuracy: ", percent_right);
        log(gwpm, nwpm, percent_right, les, dril);
    } else
        printf("\n");
}
